@echo off
rem This file loads caches and the 2nd part of the cdrom drivers
rem This drive must be A: and writeable.
rem This file also calls regional.bat to select country / language
rem If needed, this file calls FDISK and/or FORMAT
rem This file lets you call the boot disk creation tool
rem Lifecd sets more variables, while install / safe mode only
rem sets: LFN, NLSPATH, DIRCMD, LANG, PATH, CPUTYPE, DESTDRV, FDOSROOT

rem *** SUGGESTION: Move the lifecd init stuff into ONE other file,
rem *** and move DESTDRV / FORMAT / FDISK into a THIRD file and move
rem *** LANGUAGE setting and keyboard drivers / ... to a FOURTH file
rem *** REASON: those files should NOT be on A: ...!!!

SET LFN=N
SET NLSPATH=A:\FREEDOS
set dircmd=/P /OGN /4 
set lang=EN
SET PATH=A:\FREEDOS;A:\DRIVER
for %%X in ( 3 4 5 ) do if "%config%"=="%%X" goto livecd
if "%config%"=="2" goto safemode

set cputype=80386
rem Check CPU type and check for arguments passed via ISOLINUX MEMDISK
getargs.com > temp.bat
if "%errorlevel%"=="255" set cputype=80286
call temp.bat
del temp.bat

echo Checking for CDROM driver or c:\fdbootcd.iso...
set loadcd=
rem *** virtualcd variable is not set, so the next line did not work
if "%loadcd%"=="" if exist c:\fdbootcd.iso A:\DRIVER\SHSUCDHD.exe /V /F:c:\fdbootcd.iso
if exist FDCD0000 set loadcd=FDCD0000
if exist CDRCACH0 set loadcd=CDRCACH0
if exist SHSU-CDH set loadcd=SHSU-CDH
if "%loadcd%"=="" goto nocd
a:\driver\shsucdx.com /Q /D2 /D:?%loadcd%,X
if not exist X:\*.* goto nocd
echo CDROM found, checking for \freedos\setup\odin directory...
if not exist X:\FreeDOS\Setup\ODIN\*.* goto nocd
rem *** we should also check on a possible second drive, Y: ...!
echo CDROM with ODIN found!
set path=%path%;X:\FreeDOS\Setup\ODIN
rem *** what uses this variable?
set fdosroot=X:\FreeDOS\Setup

choice Select a language other than English now
if errorlevel 2 goto skipkeyb
cls
type X:\FreeDOS\Setup\language\regional.txt
echo.
echo Please enter the number corresponding to the name which best describes
set /P choice=your current location (confirm input by pressing ENTER):
if not "%choice%"=="" call X:\FreeDOS\Setup\batch\regional.bat %choice%
:skipkeyb

cls
localize.com 0.0 @@@ If you would like to install to a drive other than C,
localize.com 0.1 @@@ type the desired destination drive letter. If not,
localize.com 0.2 @@@ press enter to install to C:
set /P destdrv=
if "%destdrv%"=="" set destdrv=C
set destdrv=%destdrv%:
echo Checking if drive is accessible...
CDD %destdrv%\
if not "%_CWD%"=="%destdrv%\" goto fdiskmenu
echo Found drive:
vol %destdrv%
goto skipfdisk

:fdiskmenu
cls
set oldlang=%lang%
if not exist fdskmen.%lang% set lang=en
pbatch.exe a:\freedos\backgrou.men -fh0 -ft7 -x1 -y1 -r0 -s0
pbatch.exe a:\freedos\title.%lang% -fh1 -ft15 -x2 -y2
pbatch.exe a:\freedos\status.%lang% -fh7 -ft0 -x1 -y25 -r0 -s0
pbatch.exe a:\freedos\fdskmen.%lang% -fh1 -ft15 -m1
set lang=%oldlang%
cls
set choice=%errorlevel%
if errorlevel 6 goto fdiskmenu
rem *** XFDISK is missing on this disk!
if errorlevel 5 Fdisk.exe /REBOOT
if "%choice%"=="3" goto end
if "%choice%"=="4" goto bootdisk
if "%choice%"=="2" Fdisk.exe /MONO
if "%choice%"=="1" XFdisk.exe
set choice=
goto fdiskmenu

:skipfdisk
cdd %destdrv%\
oscheck.com %destdrv%
set os=%errorlevel%
if errorlevel 41 goto format
if %os%==1 goto format
if %os%==0 goto format
if %os%==17 goto skipformat
for %%x in ( 39 38 36 35 34 ) do if "%os%"=="%%x" copy /b a:\freedos\meta-all.bin + %destdrv%\bootsect.bin + a:\freedos\metaboot.bot %destdrv%\metakern.sys
rem *** if exist bootsect.bin del bootsect.bin
goto skipformat

:format
cls
set oldlang=%lang%
if not exist frmt.%lang% set lang=en
pbatch.exe a:\freedos\backgrou.men -fh0 -ft7 -x1 -y1 -r0 -s0
pbatch.exe a:\freedos\frmt.%lang% -fh1 -ft15 -x2 -y2
pbatch.exe a:\freedos\status.%lang% -fh7 -ft0 -x1 -y25 -r0 -s0
pbatch.exe a:\freedos\yesno.%lang% -fh1 -ft15 -m1
set lang=%oldlang%
cls
if errorlevel 3 goto format
if errorlevel 2 goto end
format.exe %destdrv% /V:FreeDOS /Q
echo FORMAT status: %errorlevel%
rem *** could jump somewhere depending on errorlevel
echo test >%destdrv%\test.tmp
if not exist %destdrv%\test.tmp localize.com 0.3 @@@ Could not format your hard disk
if not exist %destdrv%\test.tmp pause
if not exist %destdrv%\test.tmp goto format
del %destdrv%\test.tmp
A:\FREEDOS\SYS.com %destdrv% /BOOTONLY

:skipformat
echo Next step: X:\freedos\setup\batch\autorun.bat
if not exist X:\freedos\setup\batch\autorun.bat goto nocd
cdd X:\freedos\setup\batch
pause Everything ready for install. Hit enter to continue...
autorun.bat
rem should never be reached:
goto end

:bootdisk
localize 0.4 @@@ This creates a FreeDOS boot disk on your first floppy drive
pause
rem *** the real floppy is B: if we booted from CDROM, as the
rem *** cdrom contains a virtual A:. If we booted from diskette,
rem *** the real floppy is A: as usual...
mkdir b:\freedos
mkdir b:\driver
copy a:\*.* b:\
copy a:\freedos\*.* b:\freedos
copy a:\driver\*.* b:\driver
sys.com a:\ b: /BOOTONLY
pause
goto fdiskmenu

:livecd
set dosdir=x:\fdos
set path=%dosdir%\bin;%path%
if exist %dosdir%\vim set vim=%dosdir%\vim
set helppath=%dosdir%\help
set nlspath=%dosdir%\nls
set blaster=A220 I5 D1 H5 P330
if "%config%"=="3" set config=3
if "%config%"=="4" set config=3
echo Using 10 percent of free XMS for extra caches, at most 30 MB...
a:\freedos\xmssize.com 5
set xms=%errorlevel%
if errorlevel 31 set xms=30
if not "%xms%"=="0" a:\driver\devload.com /H /Q A:\DRIVER\CDRCACHE.SYS FDCD0000 CDRCACH0 %xms%000
if not "%xms%"=="0" A:\DRIVER\SHSUCDX.COM /Q /R /D:CDRCACH0 /L:X
if "%xms%"=="0" A:\DRIVER\SHSUCDX.COM /Q /R /D:FDCD0000 /L:X
if not "%xms%"=="0" loadhigh a:\driver\lbacache.com FLOP TUNS %xms%000
if not exist FDCD0000 goto nocd
if exist %dosdir%\watcom\setvars.bat call %dosdir%\watcom\setvars.bat

echo Using half of free XMS for ramdisk Z:...
a:\freedos\xmssize.com 50
set xms=%errorlevel%
set RD=Z:
if "%xms%"=="0" echo Have to use c:\tmp instead of ramdisk, no XMS free
if "%xms%"=="0" set RD=C:
rem *** can the following line ever fail?
if not exist X:\FDOS\BIN\SHSURDRV.EXE goto nocd
if not "%xms%"=="0" SHSURDRV /Q %xms%M,$RAMDISK,Z
if not "%xms%"=="0" if errorlevel 255 echo Ramdisk not loaded.
if not "%xms%"=="0" if errorlevel 255 set RD=C:
md %rd%\tmp
set tmp=%rd%\tmp
set temp=%tmp%

alias ls=ls --color=always
rem *** this should only be active for european language
rem *** lh display CON=(EGA,,1)
rem *** lh mode con cp prep=((858) %dosdir%\bin\EGA.CPX)
rem *** lh mode con cp sel=858
ctmouse.exe
rem *** why is this useful?
a:\freedos\xmssize.com 99 > NUL
set xms=%errorlevel%
rem *** what is this? autostart? should probably ask first...
if exist c:\start\dosstart.bat ?call c:\start\dosstart.bat
echo.
echo.
echo Welcome to the FreeDOS LiveCD.
echo Please type HELP to learn about commands.
echo Type MENU to launch popular programs
echo.
goto end

:nocd
echo Files on CDROM not found, driver problem or wrong CDROM?
goto end

:safemode
echo.
rem *** safe mode should depend on nothing, not even LOCALIZE
echo Welcome to the command prompt. No drivers were loaded.
echo.

:end

